Index: trunk/src/VBox/VMM/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/Makefile.kmk	(revision 20997)
+++ trunk/src/VBox/VMM/Makefile.kmk	(revision 20998)
@@ -145,4 +145,5 @@
 	VMMAll/VMAll.cpp \
 	VMMAll/VMMAll.cpp \
+	VMMAll/VMMAllA.asm \
 	PATM/CSAM.cpp \
 	PATM/VMMAll/CSAMAll.cpp \
@@ -371,4 +372,5 @@
 	VMMAll/VMAll.cpp \
 	VMMAll/VMMAll.cpp \
+	VMMAll/VMMAllA.asm \
 	PATM/VMMGC/CSAMGC.cpp \
 	PATM/VMMAll/CSAMAll.cpp \
@@ -471,5 +473,6 @@
 	VMMAll/TRPMAll.cpp \
 	VMMAll/VMAll.cpp \
-	VMMAll/VMMAll.cpp
+	VMMAll/VMMAll.cpp \
+	VMMAll/VMMAllA.asm
 ifeq ($(VBOX_LDR_FMT),pe)
  VMMR0_SOURCES += VMMR0/VMMR0.def
Index: trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp	(revision 20997)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp	(revision 20998)
@@ -28,4 +28,5 @@
 #include <VBox/pdmcritsect.h>
 #include <VBox/mm.h>
+#include <VBox/vmm.h>
 #include <VBox/vm.h>
 #include <VBox/err.h>
@@ -361,4 +362,8 @@
         AssertRC(rc);
     }
+# endif
+
+# if defined(DEBUG_bird) && defined(IN_RING0)
+    VMMTrashVolatileXMMRegs();
 # endif
 
Index: trunk/src/VBox/VMM/VMMAll/VMMAllA.asm
===================================================================
--- trunk/src/VBox/VMM/VMMAll/VMMAllA.asm	(revision 20998)
+++ trunk/src/VBox/VMM/VMMAll/VMMAllA.asm	(revision 20998)
@@ -0,0 +1,87 @@
+; $Id$
+;; @file
+; VMM - All Contexts Assembly Routines.
+;
+
+;
+; Copyright (C) 2009 Sun Microsystems, Inc.
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
+;
+
+;*******************************************************************************
+;* Header Files                                                                *
+;*******************************************************************************
+%include "VBox/asmdefs.mac"
+
+
+;*******************************************************************************
+;* Defined Constants And Macros                                                *
+;*******************************************************************************
+%ifdef IN_RING3
+ %ifdef RT_ARCH_AMD64
+  %define VMM_TRASH_XMM_REGS
+ %endif
+%endif
+%ifdef IN_RING0
+ %ifdef RT_ARCH_AMD64
+  %ifdef RT_OS_WINDOWS
+   %define VMM_TRASH_XMM_REGS
+  %endif
+ %endif
+%endif
+%ifndef VMM_TRASH_XMM_REGS
+ %ifdef VBOX_WITH_KERNEL_USING_XMM
+  %define VMM_TRASH_XMM_REGS
+ %endif
+%endif
+
+BEGINCODE
+
+
+;;
+; Trashes the volatile XMM registers in the current ABI.
+;
+BEGINPROC VMMTrashVolatileXMMRegs
+%ifdef VMM_TRASH_XMM_REGS
+        push    xBP
+        mov     xBP, xSP
+
+        ; take whatever is on the stack.
+        and     xSP, ~15
+        sub     xSP, 80h
+
+        movdqa  xmm0, [xSP + 0]
+        movdqa  xmm1, [xSP + 010h]
+        movdqa  xmm2, [xSP + 020h]
+        movdqa  xmm3, [xSP + 030h]
+        movdqa  xmm4, [xSP + 040h]
+        movdqa  xmm5, [xSP + 050h]
+ %ifdef ASM_CALL64_GCC
+        movdqa  xmm6, [xSP + 060h]
+        movdqa  xmm7, [xSP + 070h]
+        movdqa  xmm8, [xSP + 000h]
+        movdqa  xmm9, [xSP + 010h]
+        movdqa  xmm10,[xSP + 020h]
+        movdqa  xmm11,[xSP + 030h]
+        movdqa  xmm12,[xSP + 040h]
+        movdqa  xmm13,[xSP + 050h]
+        movdqa  xmm14,[xSP + 060h]
+        movdqa  xmm15,[xSP + 070h]
+ %endif
+        leave
+%endif ; VMM_TRASH_XMM_REGS
+        xor     eax, eax                ; for good measure.
+        ret
+ENDPROC
+