Index: trunk/include/VBox/DevPCNet.h
===================================================================
--- trunk/include/VBox/DevPCNet.h	(revision 21212)
+++ trunk/include/VBox/DevPCNet.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * DevPCNet - Private guest interface for the PCNet device.
+ * DevPCNet - Private guest interface for the PCNet device. (DEV)
  */
 
Index: trunk/include/VBox/VBoxDev.h
===================================================================
--- trunk/include/VBox/VBoxDev.h	(revision 21212)
+++ trunk/include/VBox/VBoxDev.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * Virtual Device for Guest <-> VMM/Host communication
+ * Virtual Device for Guest <-> VMM/Host communication (ADD,DEV).
  */
 
Index: trunk/include/VBox/VBoxGuest.h
===================================================================
--- trunk/include/VBox/VBoxGuest.h	(revision 21212)
+++ trunk/include/VBox/VBoxGuest.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VBoxGuest - VirtualBox Guest Additions Driver Interface.
+ * VBoxGuest - VirtualBox Guest Additions Driver Interface. (ADD,DEV)
  */
 
Index: trunk/include/VBox/VBoxVideo.h
===================================================================
--- trunk/include/VBox/VBoxVideo.h	(revision 21212)
+++ trunk/include/VBox/VBoxVideo.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VirtualBox Video interface
+ * VirtualBox Video interface.
  */
 
Index: trunk/include/VBox/VRDPAuth.h
===================================================================
--- trunk/include/VBox/VRDPAuth.h	(revision 21212)
+++ trunk/include/VBox/VRDPAuth.h	(revision 21217)
@@ -1,5 +1,5 @@
 /** @file
- * VBox Remote Desktop Protocol:
- * External Authentication Library Interface.
+ * VBox Remote Desktop Protocol - External Authentication Library Interface.
+ * (VRDP)
  */
 
Index: trunk/include/VBox/VRDPOrders.h
===================================================================
--- trunk/include/VBox/VRDPOrders.h	(revision 21212)
+++ trunk/include/VBox/VRDPOrders.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * VBox Remote Desktop Protocol:
- * VRDP orders structures.
+ * VBox Remote Desktop Protocol - Orders Structures. (VRDP)
  */
 
Index: trunk/include/VBox/bioslogo.h
===================================================================
--- trunk/include/VBox/bioslogo.h	(revision 21212)
+++ trunk/include/VBox/bioslogo.h	(revision 21217)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * BiosLogo - The Private BIOS Logo Interface.
+ * BiosLogo - The Private BIOS Logo Interface. (DEV)
  */
 
Index: trunk/include/VBox/cfgm.h
===================================================================
--- trunk/include/VBox/cfgm.h	(revision 21212)
+++ trunk/include/VBox/cfgm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * CFGM - Configuration Manager.
+ * CFGM - Configuration Manager. (VMM)
  */
 
Index: trunk/include/VBox/cpum.h
===================================================================
--- trunk/include/VBox/cpum.h	(revision 21212)
+++ trunk/include/VBox/cpum.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * CPUM - CPU Monitor(/ Manager).
+ * CPUM - CPU Monitor(/ Manager). (VMM)
  */
 
Index: trunk/include/VBox/cpumdis.h
===================================================================
--- trunk/include/VBox/cpumdis.h	(revision 21212)
+++ trunk/include/VBox/cpumdis.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * CPUM - CPU Monitor(/Manager)
+ * CPUM - Disassembler. (VMM)
  */
 
Index: trunk/include/VBox/csam.h
===================================================================
--- trunk/include/VBox/csam.h	(revision 21212)
+++ trunk/include/VBox/csam.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * CSAM - Guest OS Code Scanning and Analyis Manager.
+ * CSAM - Guest OS Code Scanning and Analyis Manager. (VMM)
  */
 
Index: trunk/include/VBox/dbg.h
===================================================================
--- trunk/include/VBox/dbg.h	(revision 21212)
+++ trunk/include/VBox/dbg.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * Debugger Interfaces.
+ * Debugger Interfaces. (VBoxDbg)
  *
  * This header covers all external interfaces of the Debugger module.
Index: trunk/include/VBox/dbgf.h
===================================================================
--- trunk/include/VBox/dbgf.h	(revision 21212)
+++ trunk/include/VBox/dbgf.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * DBGF - Debugger Facility.
+ * DBGF - Debugger Facility. (VMM)
  */
 
Index: trunk/include/VBox/dbgfsel.h
===================================================================
--- trunk/include/VBox/dbgfsel.h	(revision 21212)
+++ trunk/include/VBox/dbgfsel.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * DBGF - Debugger Facility, selector interface partly shared with SELM.
+ * DBGF - Debugger Facility, selector interface partly shared with SELM. (VMM)
  */
 
Index: trunk/include/VBox/dbggui.h
===================================================================
--- trunk/include/VBox/dbggui.h	(revision 21212)
+++ trunk/include/VBox/dbggui.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * DBGGUI - The VirtualBox Debugger GUI.
+ * DBGGUI - The VirtualBox Debugger GUI. (VBoxDbg)
  */
 
Index: trunk/include/VBox/em.h
===================================================================
--- trunk/include/VBox/em.h	(revision 21212)
+++ trunk/include/VBox/em.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * EM - Execution Monitor.
+ * EM - Execution Monitor. (VMM)
  */
 
Index: trunk/include/VBox/gmm.h
===================================================================
--- trunk/include/VBox/gmm.h	(revision 21212)
+++ trunk/include/VBox/gmm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * GMM - The Global Memory Manager.
+ * GMM - The Global Memory Manager. (VMM)
  */
 
Index: trunk/include/VBox/gvm.h
===================================================================
--- trunk/include/VBox/gvm.h	(revision 21212)
+++ trunk/include/VBox/gvm.h	(revision 21217)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * GVM - The Global VM Data.
+ * GVM - The Global VM Data. (VMM)
  */
 
Index: trunk/include/VBox/gvmm.h
===================================================================
--- trunk/include/VBox/gvmm.h	(revision 21212)
+++ trunk/include/VBox/gvmm.h	(revision 21217)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * GVMM - The Global VM Manager.
+ * GVMM - The Global VM Manager. (VMM)
  */
 
Index: trunk/include/VBox/hgcmsvc.h
===================================================================
--- trunk/include/VBox/hgcmsvc.h	(revision 21212)
+++ trunk/include/VBox/hgcmsvc.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * VBox - Host-Guest Communication Manager (HGCM):
- * Service library definitions.
+ * Host-Guest Communication Manager (HGCM) - Service library definitions.
  */
 
@@ -186,5 +185,5 @@
 /** Service specific extension callback.
  *  This callback is called by the service to perform service specific operation.
- *  
+ *
  * @param pvExtension The extension pointer.
  * @param u32Function What the callback is supposed to do.
@@ -243,5 +242,5 @@
      */
     DECLR3CALLBACKMEMBER(int, pfnHostCall, (void *pvService, uint32_t function, uint32_t cParms, VBOXHGCMSVCPARM paParms[]));
- 
+
     /** Inform the service about a VM save operation. */
     DECLR3CALLBACKMEMBER(int, pfnSaveState, (void *pvService, uint32_t u32ClientID, void *pvClient, PSSMHANDLE pSSM));
Index: trunk/include/VBox/hwacc_svm.h
===================================================================
--- trunk/include/VBox/hwacc_svm.h	(revision 21212)
+++ trunk/include/VBox/hwacc_svm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * HWACCM - SVM Structures and Definitions.
+ * HWACCM - SVM Structures and Definitions. (VMM)
  */
 
Index: trunk/include/VBox/hwacc_vmx.h
===================================================================
--- trunk/include/VBox/hwacc_vmx.h	(revision 21212)
+++ trunk/include/VBox/hwacc_vmx.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * HWACCM - VMX Structures and Definitions.
+ * HWACCM - VMX Structures and Definitions. (VMM)
  */
 
Index: trunk/include/VBox/hwaccm.h
===================================================================
--- trunk/include/VBox/hwaccm.h	(revision 21212)
+++ trunk/include/VBox/hwaccm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * HWACCM - Intel/AMD VM Hardware Support Manager
+ * HWACCM - Intel/AMD VM Hardware Support Manager (VMM)
  */
 
Index: trunk/include/VBox/intnet.h
===================================================================
--- trunk/include/VBox/intnet.h	(revision 21212)
+++ trunk/include/VBox/intnet.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * INETNET - Internal Networking.
+ * INETNET - Internal Networking. (DEV,++)
  */
 
Index: trunk/include/VBox/iom.h
===================================================================
--- trunk/include/VBox/iom.h	(revision 21212)
+++ trunk/include/VBox/iom.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * IOM - Input / Output Monitor.
+ * IOM - Input / Output Monitor. (VMM)
  */
 
Index: trunk/include/VBox/mm.h
===================================================================
--- trunk/include/VBox/mm.h	(revision 21212)
+++ trunk/include/VBox/mm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * MM - The Memory Manager.
+ * MM - The Memory Manager. (VMM)
  */
 
Index: trunk/include/VBox/param.h
===================================================================
--- trunk/include/VBox/param.h	(revision 21212)
+++ trunk/include/VBox/param.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VirtualBox Parameter Definitions.
+ * VirtualBox Parameter Definitions. (VMM,+)
  *
  * param.mac is generated from this file by running 'kmk incs' in the root.
Index: trunk/include/VBox/patm.h
===================================================================
--- trunk/include/VBox/patm.h	(revision 21212)
+++ trunk/include/VBox/patm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PATM - Dynamic Guest OS Patching Manager
+ * PATM - Dynamic Guest OS Patching Manager. (VMM)
  */
 
Index: trunk/include/VBox/pci.h
===================================================================
--- trunk/include/VBox/pci.h	(revision 21212)
+++ trunk/include/VBox/pci.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PCI - The PCI Controller And Devices.
+ * PCI - The PCI Controller And Devices. (DEV)
  */
 
Index: trunk/include/VBox/pdm.h
===================================================================
--- trunk/include/VBox/pdm.h	(revision 21212)
+++ trunk/include/VBox/pdm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager.
+ * PDM - Pluggable Device Manager. (VMM)
  */
 
Index: trunk/include/VBox/pdmapi.h
===================================================================
--- trunk/include/VBox/pdmapi.h	(revision 21212)
+++ trunk/include/VBox/pdmapi.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Core API.
+ * PDM - Pluggable Device Manager, Core API. (VMM)
  *
  * The 'Core API' has been put in a different header because everyone
Index: trunk/include/VBox/pdmasynccompletion.h
===================================================================
--- trunk/include/VBox/pdmasynccompletion.h	(revision 21212)
+++ trunk/include/VBox/pdmasynccompletion.h	(revision 21217)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * PDM - Pluggable Device Manager, Async I/O Completion.
+ * PDM - Pluggable Device Manager, Async I/O Completion. (VMM)
  */
 
Index: trunk/include/VBox/pdmasynctask.h
===================================================================
--- trunk/include/VBox/pdmasynctask.h	(revision 21212)
+++ trunk/include/VBox/pdmasynctask.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Async Task.
+ * PDM - Pluggable Device Manager, Async Task. (VMM)
  */
 
Index: trunk/include/VBox/pdmcritsect.h
===================================================================
--- trunk/include/VBox/pdmcritsect.h	(revision 21212)
+++ trunk/include/VBox/pdmcritsect.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Critical Sections.
+ * PDM - Pluggable Device Manager, Critical Sections. (VMM)
  */
 
Index: trunk/include/VBox/pdmdev.h
===================================================================
--- trunk/include/VBox/pdmdev.h	(revision 21212)
+++ trunk/include/VBox/pdmdev.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Devices.
+ * PDM - Pluggable Device Manager, Devices. (VMM)
  */
 
Index: trunk/include/VBox/pdmdrv.h
===================================================================
--- trunk/include/VBox/pdmdrv.h	(revision 21212)
+++ trunk/include/VBox/pdmdrv.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Drivers.
+ * PDM - Pluggable Device Manager, Drivers. (VMM)
  */
 
Index: trunk/include/VBox/pdmifs.h
===================================================================
--- trunk/include/VBox/pdmifs.h	(revision 21212)
+++ trunk/include/VBox/pdmifs.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Interfaces.
+ * PDM - Pluggable Device Manager, Interfaces. (VMM)
  */
 
Index: trunk/include/VBox/pdmins.h
===================================================================
--- trunk/include/VBox/pdmins.h	(revision 21212)
+++ trunk/include/VBox/pdmins.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Common Instance Macros.
+ * PDM - Pluggable Device Manager, Common Instance Macros. (VMM)
  */
 
Index: trunk/include/VBox/pdmqueue.h
===================================================================
--- trunk/include/VBox/pdmqueue.h	(revision 21212)
+++ trunk/include/VBox/pdmqueue.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Queues.
+ * PDM - Pluggable Device Manager, Queues. (VMM)
  */
 
Index: trunk/include/VBox/pdmsrv.h
===================================================================
--- trunk/include/VBox/pdmsrv.h	(revision 21212)
+++ trunk/include/VBox/pdmsrv.h	(revision 21217)
@@ -1,4 +1,6 @@
 /** @file
- * PDM - Pluggable Device Manager, VM Services.
+ * PDM - Pluggable Device Manager, VM Services. (VMM)
+ *
+ * @todo    This has not been implemented, consider dropping the concept.
  */
 
Index: trunk/include/VBox/pdmthread.h
===================================================================
--- trunk/include/VBox/pdmthread.h	(revision 21212)
+++ trunk/include/VBox/pdmthread.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, Threads.
+ * PDM - Pluggable Device Manager, Threads. (VMM)
  */
 
Index: trunk/include/VBox/pdmusb.h
===================================================================
--- trunk/include/VBox/pdmusb.h	(revision 21212)
+++ trunk/include/VBox/pdmusb.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PDM - Pluggable Device Manager, USB Devices.
+ * PDM - Pluggable Device Manager, USB Devices. (VMM)
  */
 
Index: trunk/include/VBox/pgm.h
===================================================================
--- trunk/include/VBox/pgm.h	(revision 21212)
+++ trunk/include/VBox/pgm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * PGM - Page Monitor / Monitor.
+ * PGM - Page Monitor / Monitor. (VMM)
  */
 
Index: trunk/include/VBox/rem.h
===================================================================
--- trunk/include/VBox/rem.h	(revision 21212)
+++ trunk/include/VBox/rem.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * REM - The Recompiled Execution Manager.
+ * REM - The Recompiled Execution Manager. (VMM)
  */
 
Index: trunk/include/VBox/scsi.h
===================================================================
--- trunk/include/VBox/scsi.h	(revision 21212)
+++ trunk/include/VBox/scsi.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VirtualBox - SCSI declarations.
+ * VirtualBox - SCSI declarations. (DEV,+)
  */
 
Index: trunk/include/VBox/selm.h
===================================================================
--- trunk/include/VBox/selm.h	(revision 21212)
+++ trunk/include/VBox/selm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * SELM - The Selector Manager.
+ * SELM - The Selector Manager. (VMM)
  */
 
Index: trunk/include/VBox/settings.h
===================================================================
--- trunk/include/VBox/settings.h	(revision 21212)
+++ trunk/include/VBox/settings.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * Settings File Manipulation API.
+ * Settings File Manipulation API. (Main)
  */
 
Index: trunk/include/VBox/shflsvc.h
===================================================================
--- trunk/include/VBox/shflsvc.h	(revision 21212)
+++ trunk/include/VBox/shflsvc.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * Shared Folders:
- * Common header for host service and guest clients.
+ * Shared Folders: Common header for host service and guest clients. (ADD,HSvc)
  */
 
@@ -38,5 +37,6 @@
 
 
-/** Some bit flag manipulation macros. to be moved to VBox/cdefs.h? */
+/** @name Some bit flag manipulation macros.
+ * @{  */
 #ifndef BIT_FLAG
 #define BIT_FLAG(__Field,__Flag)       ((__Field) & (__Flag))
@@ -50,4 +50,5 @@
 #define BIT_FLAG_CLEAR(__Field,__Flag) ((__Field) &= ~(__Flag))
 #endif
+/** @} */
 
 
Index: trunk/include/VBox/ssm.h
===================================================================
--- trunk/include/VBox/ssm.h	(revision 21212)
+++ trunk/include/VBox/ssm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * SSM - The Save State Manager.
+ * SSM - The Save State Manager. (VMM)
  */
 
Index: trunk/include/VBox/stam.h
===================================================================
--- trunk/include/VBox/stam.h	(revision 21212)
+++ trunk/include/VBox/stam.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * STAM - Statistics Manager.
+ * STAM - Statistics Manager. (VMM)
  */
 
Index: trunk/include/VBox/sup.h
===================================================================
--- trunk/include/VBox/sup.h	(revision 21212)
+++ trunk/include/VBox/sup.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * SUP - Support Library.
+ * SUP - Support Library. (HDrv)
  */
 
Index: trunk/include/VBox/tm.h
===================================================================
--- trunk/include/VBox/tm.h	(revision 21212)
+++ trunk/include/VBox/tm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * TM - Time Manager.
+ * TM - Time Manager. (VMM)
  */
 
Index: trunk/include/VBox/trpm.h
===================================================================
--- trunk/include/VBox/trpm.h	(revision 21212)
+++ trunk/include/VBox/trpm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * TRPM - The Trap Monitor.
+ * TRPM - The Trap Monitor. (VMM)
  */
 
Index: trunk/include/VBox/usb.h
===================================================================
--- trunk/include/VBox/usb.h	(revision 21212)
+++ trunk/include/VBox/usb.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * USB - Universal Serial Bus.
+ * USB - Universal Serial Bus. (DEV,Main?)
  */
 
Index: trunk/include/VBox/usblib-win.h
===================================================================
--- trunk/include/VBox/usblib-win.h	(revision 21212)
+++ trunk/include/VBox/usblib-win.h	(revision 21217)
@@ -1,5 +1,5 @@
 /** @file
- * USBLIB - USB Support Library:
- * This module implements the basic low-level OS interfaces for Windows hosts.
+ * USBLib - Library for wrapping up the VBoxUSB functionality, Windows flavor.
+ * (DEV,HDrv,Main)
  */
 
Index: trunk/include/VBox/usblib.h
===================================================================
--- trunk/include/VBox/usblib.h	(revision 21212)
+++ trunk/include/VBox/usblib.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * USBLIB - USB Support Library.
- * This module implements the basic low-level OS interfaces.
+ * USBLib - Library for wrapping up the VBoxUSB functionality. (DEV,HDrv,Main)
  */
 
Index: trunk/include/VBox/uvm.h
===================================================================
--- trunk/include/VBox/uvm.h	(revision 21212)
+++ trunk/include/VBox/uvm.h	(revision 21217)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * GVM - The Global VM Data.
+ * GVM - The Global VM Data. (VMM)
  */
 
Index: trunk/include/VBox/version.h
===================================================================
--- trunk/include/VBox/version.h	(revision 21212)
+++ trunk/include/VBox/version.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * Version management
+ * VBox Version Management.
  */
 
@@ -32,13 +32,13 @@
 
 #ifndef RC_INVOKED
-#include <version-generated.h>
+# include <version-generated.h>
 
 /** Combined version number. */
-#define VBOX_VERSION                    (VBOX_VERSION_MAJOR << 16 | VBOX_VERSION_MINOR)
+# define VBOX_VERSION                    (VBOX_VERSION_MAJOR << 16 | VBOX_VERSION_MINOR)
 /** Get minor version from combined version */
-#define VBOX_GET_VERSION_MINOR(uVer)    (uVer & 0xffff)
+# define VBOX_GET_VERSION_MINOR(uVer)    (uVer & 0xffff)
 /** Get major version from combined version. */
-#define VBOX_GET_VERSION_MAJOR(uVer)    (uVer >> 16)
-#endif
+# define VBOX_GET_VERSION_MAJOR(uVer)    (uVer >> 16)
+#endif /* !RC_INVOKED */
 
 /** Vendor name */
Index: trunk/include/VBox/vm.h
===================================================================
--- trunk/include/VBox/vm.h	(revision 21212)
+++ trunk/include/VBox/vm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VM - The Virtual Machine, data.
+ * VM - The Virtual Machine, data. (VMM)
  */
 
Index: trunk/include/VBox/vmapi.h
===================================================================
--- trunk/include/VBox/vmapi.h	(revision 21212)
+++ trunk/include/VBox/vmapi.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VM - The Virtual Machine, API.
+ * VM - The Virtual Machine, API. (VMM)
  */
 
Index: trunk/include/VBox/vmm.h
===================================================================
--- trunk/include/VBox/vmm.h	(revision 21212)
+++ trunk/include/VBox/vmm.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VMM - The Virtual Machine Monitor.
+ * VMM - The Virtual Machine Monitor. (VMM)
  */
 
Index: trunk/include/VBox/vrdpapi.h
===================================================================
--- trunk/include/VBox/vrdpapi.h	(revision 21212)
+++ trunk/include/VBox/vrdpapi.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * VBox Remote Desktop Protocol:
- * Public APIs.
+ * VBox Remote Desktop Protocol - Public APIs. (VRDP)
  */
 
Index: trunk/include/VBox/vrdpusb.h
===================================================================
--- trunk/include/VBox/vrdpusb.h	(revision 21212)
+++ trunk/include/VBox/vrdpusb.h	(revision 21217)
@@ -1,5 +1,4 @@
 /** @file
- * VBox Remote Desktop Protocol:
- * Remote USB backend interface.
+ * VBox Remote Desktop Protocol - Remote USB backend interface. (VRDP)
  */
 
Index: trunk/include/VBox/vusb.h
===================================================================
--- trunk/include/VBox/vusb.h	(revision 21212)
+++ trunk/include/VBox/vusb.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * VUSB - VirtualBox USB.
+ * VUSB - VirtualBox USB. (DEV,VMM)
  */
 
Index: trunk/include/VBox/x86.h
===================================================================
--- trunk/include/VBox/x86.h	(revision 21212)
+++ trunk/include/VBox/x86.h	(revision 21217)
@@ -1,4 +1,4 @@
 /** @file
- * X86 (and AMD64) Structures and Definitions.
+ * X86 (and AMD64) Structures and Definitions (VMM,++).
  *
  * x86.mac is generated from this file by running 'kmk incs' in the root.